//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;
struct MyBuffer {
	float4 tex0;
	float4 tex1;
};

SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

RWTexture3D<float3> outTex : BACKBUFFER;
StructuredBuffer<MyBuffer> Control;



float3 R;

[numthreads(1, 1, 1)]
void CS_Tex0( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + tid.y * R.x + tid.z * (R.y * R.x);
	uint3 idxyz = uint3(idx % R.x, floor(idx / R.x) % R.y, floor(idx / (R.x * R.y)));
	
	outTex[idxyz] = Control[idx].tex0;
}

[numthreads(1, 1, 1)]
void CS_Tex1( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + tid.y * R.x + tid.z * (R.y * R.x);
	uint3 idxyz = uint3(idx % R.x, floor(idx / R.x) % R.y, floor(idx / (R.x * R.y)));
	
	outTex[idxyz] = Control[idx].tex1;
}


technique11 Tex0
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS_Tex0() ) );
	}
}

technique11 Tex1
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS_Tex1() ) );
	}
}




